<template>

  <el-dialog
    :visible.sync="dialogVisible"
    :before-close="()=>{
      $parent.showExit = false;
    }"
    width="80%">
    <div style="padding: 0 20px">
      <h1>{{consDetails.expressNo}}-{{$t('撤销包裹订单申请')}}</h1>
      <h3>{{$t('包裹编号')}}-{{consDetails.consNum}}</h3>
      <h3>{{$t('订单编号')}}-{{consDetails.orderNo}}</h3>
      <h3>{{$t('订单状态')}}-<dict-tag :type="DICT_TYPE.ORDER_STATUS" :value="consDetails.orderStatus"/></h3>
      <el-divider></el-divider>
      <h2>{{$t('审批流程')}}</h2>
      <div style="padding: 20px">
        <work-flow xmlkey="ecw_cons_retired_warehouse" v-model="params.copyUserId"  />
      </div>
      <div>
        <el-button v-if="isExamine" @click="submit" type="primary" style="margin-right: 20px;">{{$t('确定退仓')}}</el-button>
        <el-button v-if="!isExamine" @click="goBpm" type="primary" style="margin-right: 20px;">{{$t('审核中')}}</el-button>
        <el-button  v-if="!isExamine" type="primary" style="margin-right: 20px;" @click="cancellationOfCons">{{$t('取消审核')}}</el-button>
        <el-button @click="$parent.showExit = false;">{{$t('不，再考虑考虑')}}</el-button>
      </div>
    </div>
  </el-dialog>
</template>
<!--退仓-->
<script>
import workFlow from "@/components/WorkFlow";
import ImageAndVideoUpload from "@/components/ImageAndVideoUpload/index.vue";
import {cancelApplyAndUpdate, createConsRetiredWarehouseApplication, getCons} from "@/api/ecw/cons";
import {getConsApprovalList} from "@/api/ecw/consApproval";
import {DICT_TYPE} from "@/utils/dict";

export default {
  name: "withdrawal",
  computed: {
    DICT_TYPE() {
      return DICT_TYPE
    }
  },
  props:{
    consId:Number,
    dialogVisible:Boolean
  },
  components:{
    ImageAndVideoUpload,
    workFlow
  },
  data(){
    return {
      consDetails:{},
      approvalDetail:{},
      params:{
        consId:undefined,
        expressNo:undefined,
        name:'',
        phone:'',
        address:'',
        reason:'',
        copyUserId:[],
        imgUrl:[]
      },
      isExamine:true,
      details:{},


    }
  },
  created() {
    getCons(this.consId).then(r =>{
      this.consDetails = r.data
    });
    getConsApprovalList({consId:this.consId,approvalType:0,status: 1}).then(r => {
      if(r.data.length!=0){
          this.details = r.data[0];
          this.isExamine = false;
          this.approvalDetail = JSON.parse(r.data[0].approvalDetail)
          this.params.reason = this.approvalDetail.reason
          this.params.imgUrl = this.approvalDetail.imgUrl
          this.params.name = this.approvalDetail.name
          this.params.phone = this.approvalDetail.phone
          this.params.address = this.approvalDetail.address
      }

    })
  },
  methods:{
    goBpm(){
      this.$parent.showExit = false
      this.$router.push({query:{id:this.details.formId},path:'/bpm/process-instance/detail'})
    },
    submit(){
      this.params.consId =  this.consDetails.id;
      this.params.imgUrl =  this.params.imgUrl.join(',')
      this.params.consNum =  this.consDetails.consNum
      createConsRetiredWarehouseApplication(this.params).then(r => {
       if(r.code === 0){
         this.$message.success(this.$t('退仓成功'));
         this.params = {}
         this.$parent.showExit = false
       }
      })
    },
    cancellationOfCons(){
      //仅确认取消
      this.$confirm(this.$t('是否确认取消审核？'), this.$t('提示'), {
        confirmButtonText: this.$t('确定'),
        cancelButtonText: this.$t('取消'),
        type: 'warning'
      }).then(() => {
        cancelApplyAndUpdate(this.details.id) .then(r => {
          if(r.data){
            this.$message.success(this.$t('取消成功'))
            this.params = {}
            this.$parent.showExit = false
          }
        })
      }).catch(() => {
          this.$message({
            type: 'info',
            message: this.$t('取消成功')
          })
      });

    }
  }
}
</script>

<style scoped>

</style>
